#include <p18f14k50.h> 
//#include <usart.h>
# include <string.h>
#include <stdio.h>
#include <delays.h>

	#pragma config    CPUDIV = NOCLKDIV
	#pragma config    USBDIV = OFF  
	#pragma config    FOSC = HS
	#pragma config    PLLEN = OFF 
	#pragma config    FCMEN = OFF
	#pragma config    IESO = OFF 
	#pragma config    PWRTEN = ON
	#pragma config    BOREN = ON
	#pragma config    BORV = 30
	#pragma config    WDTEN = OFF
	#pragma config    WDTPS = 1
	#pragma config    MCLRE = ON
	#pragma config    HFOFST = ON 
	#pragma config    STVREN = ON 
	#pragma config    LVP = OFF
	#pragma config    BBSIZ = OFF 
	#pragma config    XINST = OFF
	#pragma config    CP0 = ON 
	#pragma config    CPB = ON 
	#pragma config    CPD = ON 
	#pragma config    WRT1= ON 
	#pragma config    WRTB = ON 
	#pragma config    WRTC = ON 
	#pragma config    WRTD = ON 
	#pragma config    EBTRB = ON
	
// fosc = 12MHz
// Master mode

  #define SCL TRISBbits.TRISB6 // SCL line
  #define SDA TRISBbits.TRISB4 // SDA line 

// methods
void init(); 
void SendStart();
void SendStop();
void SendByte(unsigned char  data);
void ACKSTAT();
void I2CFAIL();
void SSPFlag();

void Strans(unsigned char W);

void main(void){

init();// setup
// random data
while(1){ // keep sending data
SendStart(); // send S
SendByte(0x13); // address ( write)
ACKSTAT(); // sent?
SendByte(0x42); // Register
ACKSTAT();
SendByte(0x62); // data
ACKSTAT();
SendStop();// send P (stop)

// new
//char a ='B';
//Strans ( a); // serial transition

	}
}

void init(){
ADCON1=0x07;//Configure A/D
TRISCbits.TRISC0=0;
LATCbits.LATC0=1; // light up
SDA=1; // input
SCL=1;// input
// MSSP registers 
SSPCON1=0b00101000; // IC master mode , SSPEN enable
SSPSTAT=0b10000000; // Slew Rate control (SMP) 100kHz
// baud rate 100.000kHz
SSPADD = 29; 
//(FOSC / (4 * BAUD)) -1 => Calculates SSPADD Settings
// Serial communication
TRISCbits.TRISC6=0;//TX
TRISCbits.TRISC7=1; //RX
TXSTA=0b00100000;// enable transmit 
RCSTA=0b10010000;//enable receive + serial port.
// fosc/(9600*64) -1 
SPBRG=18; // 9600 bps
//RCSTAbits.SPEN=1;//serial port.

}
// The SSPIF flag is checked to ensure the byte has been sent.
void SendStart(){
SSPCON2bits.SEN=1;
SSPFlag();
}

void SendStop(){
SSPCON2bits.PEN=1; // P activate
SSPFlag();
}

void SendByte(unsigned char data){
SSPBUF= data;
SSPFlag();
}

void I2CFAIL(){
SSPCON2bits.PEN=1;
}

void ACKSTAT(){
if ( SSPCON2bits.ACKSTAT==1){ // check ackstat
I2CFAIL(); // STOP
}
}
void SSPFlag() {
while(PIR1bits.SSPIF==0); // wait until sent
PIR1bits.SSPIF=0;
}

void Strans(unsigned char W){
while(PIR1bits.TXIF==0); // wait until the last bit is gone
TXREG=W;

}




