#include <p18f14k50.h> 
//#include <usart.h>
# include <string.h>
#include <stdio.h>
#include <delays.h>

	#pragma config    CPUDIV = NOCLKDIV
	#pragma config    USBDIV = OFF  
	#pragma config    FOSC = HS
	#pragma config    PLLEN = OFF 
	#pragma config    FCMEN = OFF
	#pragma config    IESO = OFF 
	#pragma config    PWRTEN = ON
	#pragma config    BOREN = ON
	#pragma config    BORV = 30
	#pragma config    WDTEN = OFF
	#pragma config    WDTPS = 1
	#pragma config    MCLRE = ON
	#pragma config    HFOFST = ON 
	#pragma config    STVREN = ON 
	#pragma config    LVP = OFF
	#pragma config    BBSIZ = OFF 
	#pragma config    XINST = OFF
	#pragma config    CP0 = ON 
	#pragma config    CPB = ON 
	#pragma config    CPD = ON 
	#pragma config    WRT1= ON 
	#pragma config    WRTB = ON 
	#pragma config    WRTC = ON 
	#pragma config    WRTD = ON 
	#pragma config    EBTRB = ON
	
// Slave mode

  #define SCL TRISBbits.TRISB6 // SCL line
  #define SDA TRISBbits.TRISB4 // SDA line 

	unsigned char data;

void InterruptHandlerLow (void);

// Low priority interrupt vector

#pragma code InterruptVectorLow = 0x18 // vector
void
InterruptVectorLow (void)
{
  _asm
    goto InterruptHandlerLow //jump to interrupt routine
  _endasm
}

//----------------------------------------------------------------------------
// Low priority interrupt routine

#pragma code
#pragma interrupt InterruptHandlerLow

void
InterruptHandlerLow ()
{
if ( PIR1bits.SSPIF==1){
PIR1bits.SSPIF==0;
data = SSPBUF; // read the input
TRISB=data;

	}

}


void init(); 
void main(void){

init();// setup
while(1);
}

void init (){
ADCON1=0x07;//Configure A/D
SDA=1; // input
SCL=1;// input
// SDA & SCL as inputs 
TRISB=0;
// SSPIE is located on the low vector of interrupts
PIE1bits.SSPIE=1;
INTCON = 0b11000000; // GIE and PIE enable


// SSPMSK-> No mask
// 7-Bit Slave mode:
//bit 7-1 ADD<6:0>: 7-bit address
//bit 0 Not used: Unused in this mode. Bit state is a dont care.
SSPADD=0x12; // address
SSPSTAT=0b10000000; // Slew Rate control (SMP) 100kHz
// baud rate 100.000kHz
SSPCON1= 0b00100110; // I2C Slave mode, 7-bit address , SSPEN enable
}

